;*************************************************************** 
;* 
;* 8-bites timer "Output Compare" mdjt bemutat program
;* 
;* A C port 3-as bitjn lv LED-et (active high) villogtatja 1 Hz-cel,
;* s villogtatja az OC0 lbon lv LED-et is 30 Hz-cel.
;* 
;*************************************************************** 
;* 
;*  Kszitette: Aradi Szilrd
;*  Csoport:
;*  Dtum:
;* 
;*************************************************************** 
 
.include "m128def.inc"  		; ATmega128 defincis fjl
 
;*************************************************************** 
;* Konstansok 
;*************************************************************** 
.equ	LEDnr 	= 3 			; LED-ek a 3-as biten
.equ	LEDmask = 1<<LEDnr		;1-es balra tolsa LEDnr-rel
;*************************************************************** 
;* Vltozk
;*************************************************************** 
.def	mpr1 = R16				;  ltalnos felhasznls regiszterek
.def	mpr2 = R17
.def	tcnt = R18

;*************************************************************** 
;* Makrk
;*************************************************************** 

;*************************************************************** 
;* Megszakts vektorok
;*************************************************************** 
.cseg 
.org 0x0000      				; Kdszegmens kezdcme

		jmp		init		; Reset vektor 
		jmp		dummy		; EXTINT0 Handler
		jmp		dummy		; EXTINT1 Handler
		jmp		dummy		; EXTINT2 Handler
		jmp		dummy		; EXTINT3 Handler
		jmp		dummy		; EXTINT4 Handler (INT gomb)
		jmp		dummy		; EXTINT5 Handler
		jmp		dummy		; EXTINT6 Handler
		jmp		dummy		; EXTINT7 Handler
		jmp		dummy		; Timer2 Compare Match Handler 
		jmp		dummy		; Timer2 Overflow Handler 
		jmp		dummy		; Timer1 Capture Event Handler 
		jmp		dummy		; Timer1 Compare Match A Handler 
		jmp		dummy		; Timer1 Compare Match B Handler 
		jmp		dummy		; Timer1 Overflow Handler 
		jmp		t0_oc_it	; Timer0 Compare Match Handler 
		jmp		dummy		; Timer0 Overflow Handler 
		jmp		dummy		; SPI Transfer Complete Handler 
		jmp		dummy		; USART0 RX Complete Handler 
		jmp		dummy		; USART0 Data Register Empty Hanlder 
		jmp		dummy		; USART0 TX Complete Handler 
		jmp		dummy		; ADC Conversion Complete Handler 
		jmp		dummy		; EEPROM Ready Hanlder 
		jmp		dummy		; Analog Comparator Handler 
		jmp		dummy		; Timer1 Compare Match C Handler 
		jmp		dummy		; Timer3 Capture Event Handler 
		jmp		dummy		; Timer3 Compare Match A Handler 
		jmp		dummy		; Timer3 Compare Match B Handler 
		jmp		dummy		; Timer3 Compare Match C Handler 
		jmp		dummy		; Timer3 Overflow Handler 
		jmp		dummy		; USART1 RX Complete Handler 
		jmp		dummy		; USART1 Data Register Empty Hanlder 
		jmp		dummy		; USART1 TX Complete Handler 
		jmp		dummy		; Two-wire Serial Interface Handler 
		jmp		dummy		; Store Program Memory Ready Handler 
;*****************************************************************************
;* Inicializls
;*****************************************************************************

;***** Stack inicializlsa *****

init:	ldi		mpr1,LOW(RAMEND)	; RAMEND = RAM vgcme
		out		SPL,mpr1			; (ld."m128def.inc") 
		ldi		mpr1,HIGH(RAMEND)
		out		SPH,mpr1

;*****************************************************************************
;* Fprogram
;*****************************************************************************		

main:
		ldi		mpr1,LEDmask
		out		DDRC,mpr1
		ldi		mpr1,0x10
		out		DDRB,mpr1
										

		ldi		mpr1,0x1F
		out		TCCR0,mpr1		
		ldi		mpr1,255		
		out		OCR0,mpr1		
		in		mpr1,TIMSK
		ori		mpr1,1<<OCIE0	;Timer0 OC IT enabled
		out		TIMSK,mpr1

		; 1024 prescaler, CTC mode (clear on compare match) OC0 disconnected
		; TCCR0: FC0 WGM00 COM01 CM00 WGM01 CS02 CS01 CS00
		;         0    0    0     1     1     1    1    1
		; f = 8000000/(1024*255) = 30.63 Hz (32.65 ms)  1/30.63=0.032648 <-- ennyi msodpercenknt fog belefutni az interruptba

		ldi		tcnt,30		
		sei

loop:	jmp		loop;			; Vgtelen hurok
		
;*****************************************************************************
;* Szubrutinok
;*****************************************************************************

;*****************************************************************************
;* Megszakts kezel rutinok
;*****************************************************************************
t0_oc_it:
		push	mpr1			;mpr1 veremtrba
		push	mpr2			;mpr2 veremtrba
		dec		tcnt			;tcnt cskkentse
		brne	exit_t0_it		
		in		mpr1,PORTC
		ldi		mpr2,LEDmask
		eor		mpr1,mpr2
		out		PORTC,mpr1


		ldi		tcnt,30
exit_t0_it:
		pop		mpr2			;mpr2 kiolvassa veremtrbl
		pop		mpr1			;mpr1 kiolvassa veremtrbl
		reti					

dummy: reti
;*****************************************************************************
;* Adatok
;*****************************************************************************
